﻿SuperPVP = {}

spvp_ui = UI.CreateContext("Prestige Bar Context")
spvp_background = UI.CreateFrame("Texture","Prestige Bar",spvp_ui)

spvp_overlay = UI.CreateFrame("Frame","Clicking Overlay",spvp_ui)

--local spvp_fillbar = UI.CreateFrame("Frame","Fill Bar",spvp_ui)
local spvp_fillbar = UI.CreateFrame("Texture","Fill Bar",spvp_ui)
local spvp_rank = UI.CreateFrame("Texture","Rank Texture",spvp_ui)
local spvp_ranktext = UI.CreateFrame("Text","Rank Text",spvp_ui)
local spvp_rankshadow = UI.CreateFrame("Text","Rank Shadow",spvp_ui)
local spvp_prestext = UI.CreateFrame("Text","Prestige Text",spvp_ui)
local spvp_prestigeicon = UI.CreateFrame("Texture","Prestige Icon",spvp_ui)

spvp_moveable = false

function SuperPVP.Main(a)
	if a~= "SuperPVP" then
		return
	end
	if not spvpSave then
		SuperPVP.SetDefaults()
	end
	if not spvpSave.rank then
		spvpSave.rank = true
	end
	if not spvpSave.fontsize then
		spvpSave.fontsize = 10
	end
	if not spvpSave.favor then
		spvpSave.favor = false
	end
	if not spvpSave.planarite then
		spvpSave.planarite = false
	end
	if not spvpSave.scale then
		spvpSave.scale = 1
	end
	if not spvpSave.killConsole then
		spvpSave.killConsole = "general"
	end
	SuperPVP.Build()
	SuperPVP.FavorBarBuild()
	SuperPVP.PlanariteBarBuild()
	SuperPVP.InitOverlay()
	print("Super PvP has initialized.")
	Command.Console.Display("general", true, "\t  <font color='#cc0000'>/spvp favor</font> - toggle on/off <font color='#fbec6e'>favor</font> bar.", true)
	Command.Console.Display("general", true, "\t  <font color='#cc0000'>/spvp planarite</font> - toggle on/off <font color='#9e12f6'>planarite</font> bar.", true)
	Command.Console.Display("general", true, "\t  <font color='#cc0000'>/spvp rank</font> - toggle on/off <font color='#009cff'>prestige</font> rank box.", true)
	Command.Console.Display("general", true, "\t  <font color='#cc0000'>/spvp kb</font> - toggle on/off kill chat.", true)
	Command.Console.Display("general", true, "\t  <font color='#cc0000'>/spvp killprint consoleName</font> - change the output console for kills.", true)
	Command.Console.Display("general", true, "\t  <font color='#cc0000'>/spvp help</font> - full list of commands for SuperPVP.", true)
end
function SuperPVP.InitOverlay()
	spvp_overlay:SetVisible(true)
	--spvp_overlay:SetTexture("SuperPVP","bar_bg.png")
	spvp_overlay:SetLayer(10)
	spvp_overlay:SetBackgroundColor(1,1,1,0)
	spvp_overlay:SetPoint("TOPLEFT",spvp_ui,"TOPLEFT",spvpSave.x,spvpSave.y)
	spvp_overlay:SetWidth(spvp_background:GetTextureWidth()*spvpSave.scale)
	local count = 1
	if spvpSave.favor then
		count = count + 1
	end
	if spvpSave.planarite then
		count = count + 1
	end
	spvp_overlay:SetHeight((spvp_background:GetTextureHeight()*spvpSave.scale)*count)	
end

function SuperPVP.Build()
	spvp_background:SetVisible(true)
	spvp_background:SetTexture("SuperPVP","bar_bg.png")
	spvp_background:SetLayer(1)
	spvp_background:SetPoint("TOPLEFT",spvp_overlay,"TOPLEFT",0,0)
	spvp_background:SetWidth(spvp_background:GetTextureWidth()*spvpSave.scale)
	spvp_background:SetHeight(spvp_background:GetTextureHeight()*spvpSave.scale)	
	spvp_prestigeicon:SetTexture("SuperPVP","prestige_icon.png")
	spvp_prestigeicon:SetWidth(spvp_prestigeicon:GetTextureWidth()*(.25*spvpSave.scale))
	spvp_prestigeicon:SetHeight(spvp_prestigeicon:GetTextureHeight()*(.25*spvpSave.scale))
	spvp_prestigeicon:SetLayer(2)
	spvp_prestigeicon:SetPoint("TOPLEFT",spvp_overlay,"TOPLEFT",-spvp_prestigeicon:GetTextureWidth()*(.25*spvpSave.scale)+1,0)
	spvp_prestigeicon:SetVisible(true)	
	---------------------------------------------------------------------------------
	
	function spvp_overlay.Event:LeftDown()
		spvp_overlay.leftDown = true
		local mouse = Inspect.Mouse()
		spvp_overlay.originalXDiff = mouse.x - spvp_overlay:GetLeft()
		spvp_overlay.originalYDiff = mouse.y - spvp_overlay:GetTop()
		local left, top, right, bottom = spvp_overlay:GetBounds()
	end
	function spvp_overlay.Event:LeftUp()
		spvp_overlay.leftDown = false
	end
	function spvp_overlay.Event:LeftUpoutside()
		spvp_overlay.leftDown = false
	end
	function spvp_overlay.Event:MouseMove(x, y)
		if not spvp_overlay.leftDown then
			return
		end
		local newX = x - self.originalXDiff
		local newY = y - self.originalYDiff
		spvp_overlay:SetPoint("TOPLEFT", spvp_ui, "TOPLEFT", newX, newY)
		spvpSave.x = newX
		spvpSave.y = newY
	end
	
	spvp_fillbar:SetVisible(true)
	--spvp_fillbar:SetBackgroundColor(spvpSave.red,spvpSave.green,spvpSave.blue,spvpSave.alpha)
	spvp_fillbar:SetTexture("SuperPVP","progress_prestige.png")
	spvp_fillbar:SetLayer(2)
	spvp_fillbar:SetHeight(spvp_background:GetTextureHeight()*spvpSave.scale)
	spvp_fillbar:SetWidth(0)
	spvp_fillbar:SetPoint("TOPLEFT",spvp_background,"TOPLEFT",0,0)
	
	spvp_prestext:SetVisible(false)
	spvp_prestext:SetText("")
	spvp_prestext:SetLayer(3)
	spvp_prestext:SetFontSize(math.ceil(spvpSave.fontsize*spvpSave.scale))
	spvp_prestext:SetFontColor(spvpSave.fontred,spvpSave.fontgreen,spvpSave.fontblue,spvpSave.fontalpha)
	spvp_prestext:SetPoint("TOPLEFT",spvp_ui,"TOPLEFT",spvpSave.x,spvpSave.y)
	
	spvp_rank:SetVisible(false)
	spvp_rank:SetLayer(0)
	spvp_rank:SetTexture("SuperPVP","bar_rank.png")
	--implement bar centering here
	
	SuperPVP.CenterBars()
	
	spvp_ranktext:SetVisible(false)
	spvp_ranktext:SetLayer(7)
	spvp_ranktext:SetFontSize(math.ceil(18*spvpSave.scale))
	spvp_ranktext:SetFontColor(1,1,1,1)
	
	spvp_rankshadow:SetVisible(false)
	spvp_rankshadow:SetLayer(6)
	spvp_rankshadow:SetFontSize(math.ceil(18*spvpSave.scale))
	spvp_rankshadow:SetFontColor(0,0,0,1)
end

function SuperPVP.CenterBars() 
	local count_bars = 1
	if spvpSave.favor
		then 
		count_bars = count_bars + 1
	end
	if spvpSave.planarite
		then
		count_bars = count_bars + 1
	end
	--dump(count_bars)
	local vert_offset = 0
	local vert_scalar = spvp_background:GetTextureHeight() / 2
	vert_offset = vert_scalar * (count_bars - 1)
	--dump(vert_offset)
	spvp_rank:SetPoint("CENTERLEFT",spvp_background,"CENTERLEFT",-spvp_rank:GetTextureWidth()*spvpSave.scale+1,vert_offset*spvpSave.scale)
end

function SuperPVP.GetPlayerInfo(spvp_unit)
	for mpd_id,spvp_specifier in pairs(spvp_unit) do
		if spvp_specifier == "player" and Utility.Unit.Availability().full.availability then
			local spvp_prestige = Inspect.Pvp.Prestige()
			SuperPVP.TrackPrestige(spvp_prestige.accumulated,spvp_prestige.needed)
			SuperPVP.SetText(spvp_prestige.accumulated)
			SuperPVP.SetRankButton(spvp_prestige.rank)
			
			if spvpSave.favor then
				local spvp_favor = Inspect.Currency.Detail("I1BE979014977916D,D836143579B97398,,,,,,")
				if spvp_favor then
					SuperPVP.FavorBar(spvp_favor)
				end
			end
			
			if spvpSave.planarite then
				local spvp_planarite = Inspect.Currency.Detail("I40FE419D87662CDA,018726C4E158FF25,,,,,,")
				
				if spvp_planarite then
					SuperPVP.PlanariteBar(spvp_planarite)
				end
			end
			
		end
	end
	
end

function SuperPVP.TrackPrestige(spvp_accum)	
	local spvp_needed = Inspect.Pvp.Prestige().needed
	if spvp_accum then
		local spvp_percent = (spvp_accum/spvp_needed)
		spvp_fillbar:SetWidth(spvp_background:GetWidth()*spvp_percent)
	elseif not spvp_accum and not spvp_needed and Inspect.Unit.Detail('player').level >= 50 then
		spvp_fillbar:SetWidth(spvp_background:GetWidth())
	else
		spvp_fillbar:SetWidth(0)
	end
end

function SuperPVP.SetText(spvp_accum)
	if Inspect.Unit.Detail('player').level >= 50 then
		spvp_needed = Inspect.Pvp.Prestige().needed
		if spvp_accum then
			local spvp_percent = (spvp_accum/spvp_needed)*100											
			if spvp_percent >= 10 then
				spvp_prestext:SetText(tostring(spvp_accum) .. "/" .. tostring(spvp_needed) .. " " .. "(" .. string.sub(tostring((spvp_accum/spvp_needed)*100),1,2) .. "%)")
			else
				spvp_prestext:SetText(tostring(spvp_accum) .. "/" .. tostring(spvp_needed) .. " " .. "(" .. string.sub(tostring((spvp_accum/spvp_needed)*100),1,1) .. "%)")
			end
		elseif not spvp_accum and not spvp_needed then
			spvp_prestext:SetText("MAX")
		end
	else
		spvp_prestext:SetText("PRESTIGE BEGINS AT LEVEL 50")
	end
	local left,top,right,bottom = spvp_background:GetBounds()
	local lefttext,toptext,righttext,bottomtext = spvp_prestext:GetBounds()
	local width = spvp_prestext:GetWidth()
	local middle = (right - left)/2
	local offset = (righttext - lefttext)/2
	local v_offset = (bottomtext - toptext)/2 
	local v_middle = (bottom - top)/2
	local repo = (middle - offset)
	local v_repo = (v_middle - v_offset)
	--print(lefttext, righttext, width)
	spvp_prestext:SetPoint("TOPLEFT",spvp_background,"TOPLEFT",repo,v_repo)
	spvp_prestext:SetVisible(true)		
end

function SuperPVP.SetRankButton(spvp_rank_num)
	if spvpSave.rank then
		--spvp_rank:SetTexture("SuperPVP","bar_rank.png")			
		spvp_rank:SetWidth(spvp_rank:GetTextureWidth()*spvpSave.scale)
		spvp_rank:SetHeight(spvp_rank:GetTextureHeight()*spvpSave.scale)
		spvp_ranktext:ClearAll()
		spvp_rankshadow:ClearAll()
		local left,top,right,bottom = spvp_rank:GetBounds()
		spvp_ranktext:SetText(tostring(spvp_rank_num))
		spvp_rankshadow:SetText(tostring(spvp_rank_num))
		local leftrank,toprank,rightrank,bottomrank = spvp_ranktext:GetBounds()
		local diffright = (right - rightrank)
		local diffleft = (left - leftrank)
		local difftop = (top - toprank)
		local diffbottom = (bottom - bottomrank)
		local horizrepo = ((diffright - diffleft) / 2) - 5*spvpSave.scale
		local vertrepo = ((diffbottom - difftop) / 2)
		local rankleft = spvp_ranktext:GetLeft()
		local ranktop = spvp_ranktext:GetTop()
		--set location of prestige rank text
		spvp_ranktext:SetPoint("TOPLEFT",spvp_rank,"TOPLEFT",horizrepo+1,vertrepo)
		spvp_rankshadow:SetPoint("TOPLEFT",spvp_rank,"TOPLEFT",horizrepo,vertrepo)
		spvp_ranktext:SetVisible(true)
		spvp_rankshadow:SetVisible(true)
		spvp_rank:SetVisible(true)
	end
end

function SuperPVP.Update(spvp_accum)
	SuperPVP.TrackPrestige(spvp_accum)
	SuperPVP.SetText(spvp_accum)
end

function SuperPVP.UpdateBars()
	SuperPVP.Build()
	
	local spvp_info = Inspect.Pvp.Prestige()
	SuperPVP.Update(spvp_info.accumulated)	
	SuperPVP.SetRankButton(spvp_info.rank)
	
	
	SuperPVP.PlanariteBarBuild()
	local spvp_planarite = Inspect.Currency.Detail("I40FE419D87662CDA,018726C4E158FF25,,,,,,")
	SuperPVP.PlanariteBar(spvp_planarite)
	
	
	SuperPVP.FavorBarBuild()
	local spvp_favor = Inspect.Currency.Detail("I1BE979014977916D,D836143579B97398,,,,,,")
	SuperPVP.FavorBar(spvp_favor)

	
	--we may have added or removed a bar, recalculate and center bars
	SuperPVP.CenterBars()
	SuperPVP.InitOverlay()
end

function SuperPVP.SetDefaults()
    local center_x = (UIParent:GetWidth())/2
	local center_y = (UIParent:GetHeight())/2
	spvpSave = {
				x = center_x,
				y = center_y,
				rank = true,
				red = 0,
				green = 0,
				blue = 0.8,
				alpha = 0.8,
				fontred = 1,
				fontgreen = 1,
				fontblue = 1,
				fontalpha = 1,
				fontsize = 10,
				favor = true,
				planarite = true,
				scale = 1,
				kb = true,
				killConsole = "general"
		}
end

function SuperPVP.PrintHelp()
	Command.Console.Display("general", true, "Below is a list of all the commands currently supported by SuperPVP:", true)
	Command.Console.Display("general", true, "\t  <font color='#cc0000'>/spvp favor</font> - toggle on/off <font color='#fbec6e'>favor</font> bar.", true)
	Command.Console.Display("general", true, "\t  <font color='#cc0000'>/spvp help</font> - full list of commands for SuperPVP.", true)	
	Command.Console.Display("general", true, "\t  <font color='#cc0000'>/spvp kb</font> - toggle on/off kill chat.", true)
	Command.Console.Display("general", true, "\t  <font color='#cc0000'>/spvp killprint consoleName</font> - change the output console for kills.", true)
	Command.Console.Display("general", true, "\t  <font color='#cc0000'>/spvp planarite</font> - toggle on/off <font color='#9e12f6'>planarite</font> bar.", true)
	Command.Console.Display("general", true, "\t  <font color='#cc0000'>/spvp rank</font> - toggle on/off <font color='#009cff'>prestige</font> rank box.", true)
	Command.Console.Display("general", true, "\t  <font color='#cc0000'>/spvp default</font> - set SuperPVP to default settings.", true)
	Command.Console.Display("general", true, "\t  <font color='#cc0000'>/spvp scale [0.50-2.00]</font> - scales the progress bars and text by value.", true)
	Command.Console.Display("general", true, "\t  <font color='#cc0000'>/spvp player</font> - [DEBUG] dumps information about the player.", true)
	Command.Console.Display("general", true, "\t  <font color='#cc0000'>/spvp target</font> - [DEBUG] dumps information about the current target.", true)
	
end

function SuperPVP.SlashHandler(args)
	local cmd = {}
    local numargs = 0
    local numargs = 0
	for token in string.gmatch(args, "[^%s]+") do
			cmd[numargs] = token
			numargs = numargs + 1
	end
	if cmd[0] == "rank" then
		spvpSave.rank = not spvpSave.rank
		if spvpSave.rank then
			spvp_ranktext:SetVisible(true)
			spvp_rankshadow:SetVisible(true)
			spvp_rank:SetVisible(true)
			print("Showing Rank Box")
		else
			spvp_ranktext:SetVisible(false)
			spvp_rankshadow:SetVisible(false)
			spvp_rank:SetVisible(false)
			print("Hiding Rank Box")
		end
	elseif cmd[0] == "default" then
		SuperPVP.SetDefaults()
		SuperPVP.Build()
		SuperPVP.GetPlayerInfo({id ="player"})
		print("Super PvP set to default settings.")
	elseif cmd[0] == "scale" then
		local spvp_scalenum = tonumber(cmd[1])
		if 0.5 <= spvp_scalenum and spvp_scalenum <= 2 then
			spvpSave.scale = spvp_scalenum
			SuperPVP.Build()
			SuperPVP.FavorBarBuild()
			SuperPVP.PlanariteBarBuild()
			SuperPVP.InitOverlay()
			SuperPVP.GetPlayerInfo({id ="player"})
			local seeifworks = Inspect.Pvp.Prestige()
			SuperPVP.SetRankButton(seeifworks.rank)
		else
			print("Please enter a number between 0.5 and 2")
		end
	elseif cmd[0] == "favor" then
		spvpSave.favor = not spvpSave.favor
		SuperPVP.FavorBarBuild()
		SuperPVP.UpdateBars()
		if spvpSave.favor then
			print("Displaying Favor Bar")
			spvp_favortext:SetVisible(true)
		else
			spvp_favortext:SetVisible(false)
			print("Favor Bar is Hidden")
		end
	elseif cmd[0] == "planarite" then
		spvpSave.planarite = not spvpSave.planarite
		SuperPVP.UpdateBars()
		if spvpSave.planarite then
			spvp_planaritetext:SetVisible(true)
			print("Displaying Planarite Bar")
		else
			spvp_planaritetext:SetVisible(false)
			print("Planarite Bar is Hidden")
		end
	elseif cmd[0] == "fontsize" then
		if tonumber(cmd[1]) <= 0 then
			print("Please choose a size larger than 0")
		else
			spvpSave.fontsize = tonumber(cmd[1])
			SuperPVP.UpdateBars()
		end
	elseif cmd[0] == "player" then
		dump(Inspect.Unit.Detail("player"))
	elseif cmd[0] == "target" then
		dump(Inspect.Unit.Detail("player.target"))
	elseif cmd[0] == "kb" then
		spvpSave.kb = not spvpSave.kb
		if spvpSave.kb then
			print("Displaying killing blows.")
		else
			print("Killing blows are now off.")
		end
	elseif cmd[0] == "help" then
		SuperPVP.PrintHelp()
	elseif cmd[0] == "killprint" then
		consoles = Inspect.Console.List()
		for i, k in pairs(consoles) do
			conInfo = Inspect.Console.Detail(i)
			if cmd[1] and string.lower(cmd[1]) == string.lower(conInfo.name) then
				spvpSave.killConsole = i
				Command.Console.Display(spvpSave.killConsole, false, "<font color='#FF0000'>Kill messages will now appear in this console!</font>", true)
				return
			end
		end
		print("The console '" .. cmd[1] .. "' was not found!")
	else
		print("Not a valid slash command for Super's Prestige Bar.")
	end
end

function processKill(info)
	--If KBs are disabled or we are zoning when something dies, return. Otherwise, ONWARD!
	if not spvpSave.kb or not Utility.Unit.Availability().full.availability then
		return
	else
		victimName = info.targetName
		px = Inspect.Unit.Detail("player").coordX
		py = Inspect.Unit.Detail("player").coordY
		pz = Inspect.Unit.Detail("player").coordZ
		tx = Inspect.Unit.Detail(info.target).coordX
		ty = Inspect.Unit.Detail(info.target).coordY
		tz = Inspect.Unit.Detail(info.target).coordZ
		distance = math.sqrt((px-tx)^2 + (py-ty)^2 + (pz-tz)^2)
		distance = math.ceil(distance)
		if info.caster then
			killerName = info.casterName	
			killerInfo = Inspect.Unit.Detail(info.caster)
		end
		victimInfo = Inspect.Unit.Detail(info.target)
		-- if the event triggered a kill but victim was nil
		if not victimName then
			victimName = "???"
		else
			victimInfo = Inspect.Unit.Detail(info.target)
			victimStyle = "<font color='" .. killStyle(victimInfo) .. "'>"
			--dump(victimInfo)
		end
		--IF victim is the Player and the victim was less than 100m away. This keeps Player from being bombarded by raid/party member deaths across the map.	
		if victimInfo.player and distance <= 100 then
			if not killerName then
				victimFinal = victimStyle .. victimName .. "</font> was killed. (" .. distance .. "m)"
				Command.Console.Display(spvpSave.killConsole, false, victimFinal, true)
			else
				killerStyle = "<font color='" .. killStyle(killerInfo) .. "'>"
				killFinal = killerStyle .. killerName .. "</font> -> " .. victimStyle .. victimName .. "</font> (" .. distance .. "m)"
				Command.Console.Display(spvpSave.killConsole, false, killFinal, true)
			end
		end
	end
end
--Return HTML Color Code for faction of player passed
function killStyle(info)
	if info then
		--if we are in CQ
		if info.id == Inspect.Unit.Detail("player").id then
			--this is the player, so style will be a highlighting green, for clarity sake.
			return "#00dd00"
		else
			if info.factionId then
				if info.factionId == "f000000117FB54BCE" then
					--oath
					return "#ffcc00"
				elseif info.factionId == "f000000108924207A" then
					--nf
					return "#525dee"
				elseif info.factionId == "f0000000FEDCF3A7E" then
					--dom
					return "#327f86"
				end
			else
			-- else we are in a WF or open world
				if info.alliance == "defiant" then
					--defiant
					return "#e6382a"
				elseif info.alliance == "guardian" then
					--guardian
					return "#37d5fd"
				else
					return "#FFFFFF"
				end
			end
		end
	end
	return "#FFFFFF"
end

table.insert(Event.Combat.Death, {processKill, "SuperPVP", "Event - something died." } )
table.insert(Event.Addon.Load.End, { SuperPVP.Main, "SuperPVP", "Addon Load" } )
table.insert(Event.Unit.Availability.Full, { SuperPVP.GetPlayerInfo, "SuperPVP", "Get info when the unit is available" } )
table.insert(Event.Pvp.Prestige.Accumulated, { SuperPVP.Update, "SuperPVP", "Prestige has updated" } )
table.insert(Command.Slash.Register("spvp"), { SuperPVP.SlashHandler, "SuperPVP", "Slash Commands" } )