﻿spvp_favorbar = UI.CreateFrame("Texture","Favor Bar",spvp_ui)
spvp_favortext = UI.CreateFrame("Text","Favor Text",spvp_ui)
spvp_favorbg = UI.CreateFrame("Texture","Favor Background Bar",spvp_ui)
local spvp_favoricon = UI.CreateFrame("Texture","Favor Icon",spvp_ui)
local spvp_maxFavor = nil
local offset = 1

function SuperPVP.FavorBarBuild()
	if spvpSave.favor then
		spvp_favorbar:SetVisible(true)
		spvp_favorbg:SetVisible(true)
		spvp_favoricon:SetVisible(true)
	else
		spvp_favorbar:SetVisible(false)
		spvp_favorbg:SetVisible(false)
		spvp_favoricon:SetVisible(false)
	end	
	spvp_favorbg:SetTexture("SuperPVP","bar_bg.png")
	spvp_favorbg:SetLayer(1)
	spvp_favorbg:SetWidth(spvp_favorbg:GetTextureWidth()*spvpSave.scale)
	spvp_favorbg:SetHeight(spvp_favorbg:GetTextureHeight()*spvpSave.scale)	
	spvp_favorbg:SetPoint("TOPLEFT",spvp_overlay,"TOPLEFT",0,spvp_background:GetHeight()*offset)
end

function SuperPVP.FavorBar(spvp_favor)
	if spvpSave.favor then			
		--Setup favor icon
		spvp_favorbar:SetLayer(2)
		spvp_favorbar:SetHeight(10*spvpSave.scale)
		spvp_favorbar:SetWidth(0)
		spvp_favorbar:SetTexture("SuperPVP","progress_favor.png")
		local favor_url = spvp_favor.icon
		spvp_favoricon:SetTexture("Rift", favor_url)	
		spvp_favoricon:SetWidth(spvp_favoricon:GetTextureWidth()*(.24*spvpSave.scale))
		spvp_favoricon:SetHeight(spvp_favoricon:GetTextureHeight()*(.24*spvpSave.scale))
		spvp_favoricon:SetLayer(2)
		spvp_favoricon:SetPoint("TOPLEFT",spvp_overlay,"TOPLEFT",-spvp_favoricon:GetTextureWidth()*(.24*spvpSave.scale)+1,spvp_background:GetHeight())
		spvp_favorbar:SetPoint("TOPLEFT",spvp_overlay,"TOPLEFT",0,spvp_background:GetHeight()*offset)
		spvp_favoricon:SetVisible(false)	
		local spvp_count = spvp_favor.stack
		spvp_maxFavor = spvp_favor.stackMax
		local spvp_percent = spvp_count/spvp_maxFavor
		--Fill the progress bar	
		spvp_favorbar:SetWidth(spvp_percent*spvp_background:GetWidth())	
		if spvp_percent >= 0.90 then
			spvp_favorbar:SetTexture("SuperPVP","progress_high.png")
		else
			spvp_favorbar:SetTexture("SuperPVP","progress_favor.png")
		end
		
		--Set the XX/YY (%%) text
		SuperPVP.SetFavorText(spvp_count)
		--draw the favor icon
		spvp_favoricon:SetVisible(true)	
	end
end

function SuperPVP.SetFavorText(spvp_favor)
	spvp_favortext:SetFontSize(math.ceil(spvpSave.fontsize*spvpSave.scale))
	spvp_favortext:SetLayer(3)
	spvp_favortext:SetFontColor(1,1,1,1)
	local spvp_favor_percent = (spvp_favor/spvp_maxFavor)*100
	if spvp_favor_percent >= 100 then
		spvp_favortext:SetText(tostring(spvp_favor) .. "/" .. tostring(spvp_maxFavor) .. " " .. "(" .. string.sub(tostring(spvp_favor_percent),1,3) .. "%)")
	elseif spvp_favor_percent >= 10 then
		spvp_favortext:SetText(tostring(spvp_favor) .. "/" .. tostring(spvp_maxFavor) .. " " .. "(" .. string.sub(tostring(spvp_favor_percent),1,2) .. "%)")	
	else
		spvp_favortext:SetText(tostring(spvp_favor) .. "/" .. tostring(spvp_maxFavor) .. " " .. "(" .. string.sub(tostring(spvp_favor_percent),1,1) .. "%)")
	end
	local left,top,right,bottom = spvp_favorbg:GetBounds()
	local lefttext,toptext,righttext,bottomtext = spvp_favortext:GetBounds()
	local repo = (right - righttext)/2
	spvp_favortext:SetPoint("CENTER",spvp_favorbg,"CENTER",0,0)
	spvp_favortext:SetVisible(true)
end

function SuperPVP.FavorUpdate(spvp_curr)
	if spvpSave.favor then
		for id,amount in pairs(spvp_curr) do
			if id == "I1BE979014977916D,D836143579B97398,,,,,," then
				if spvp_maxFavor then
					local spvp_percent = amount/spvp_maxFavor
					spvp_favorbar:SetWidth(spvp_percent*spvp_background:GetWidth())
					spvp_favorbar:SetWidth(spvp_percent*spvp_background:GetWidth())
					favor_curr = spvp_amount
					--print("favor_curr:", favor_curr, " favor amount:",amount)
					SuperPVP.SetFavorText(amount)
					if spvp_percent >= 0.90 then
						spvp_favorbar:SetTexture("SuperPVP","progress_high.png")
					else
						spvp_favorbar:SetTexture("SuperPVP","progress_favor.png")
					end
				end
			end
		end
	end
end

table.insert(Event.Currency, { SuperPVP.FavorUpdate, "SuperPVP", "Favor Updated" } )