spvp_planaritebar = UI.CreateFrame("Texture","Planarite Bar",spvp_ui)
spvp_planaritetext = UI.CreateFrame("Text","Planarite Text",spvp_ui)
spvp_planaritebg = UI.CreateFrame("Texture","Planarite Background Bar",spvp_ui)
local spvp_planariteicon = UI.CreateFrame("Texture","Planarite Icon",spvp_ui)
local spvp_planarite_max = nil

function SuperPVP.PlanariteBarBuild()
	if spvpSave.planarite then
		spvp_planaritebar:SetVisible(true)
		spvp_planaritebg:SetVisible(true)
		spvp_planariteicon:SetVisible(true)
	else
		spvp_planaritebar:SetVisible(false)
		spvp_planaritebg:SetVisible(false)
		spvp_planariteicon:SetVisible(false)
	end	
	spvp_planaritebg:SetTexture("SuperPVP","bar_bg.png")
	spvp_planaritebg:SetLayer(1)
	spvp_planaritebg:SetWidth(spvp_planaritebg:GetTextureWidth()*spvpSave.scale)
	spvp_planaritebg:SetHeight(spvp_planaritebg:GetTextureHeight()*spvpSave.scale)
	spvp_planaritebg:SetPoint("TOPLEFT",spvp_overlay,"TOPLEFT",0,spvp_background:GetHeight()*2)
end

function SuperPVP.PlanariteBar(spvp_planarite)
	if spvpSave.planarite then
		--setup planarite icon
		local offset = 1
		if spvpSave.favor then
			 offset = 2
		end	
		spvp_planaritebar:SetLayer(2)
		spvp_planaritebar:SetHeight(10*spvpSave.scale)
		spvp_planaritebar:SetWidth(0)
		--Setup Planarite Icon
		local planarite_url = spvp_planarite.icon
		spvp_planariteicon:SetTexture("Rift", planarite_url)
		spvp_planariteicon:SetTexture("Rift", planarite_url)
		spvp_planariteicon:SetWidth(spvp_planariteicon:GetTextureWidth()*(.24*spvpSave.scale))
		spvp_planariteicon:SetHeight(spvp_planariteicon:GetTextureHeight()*(.24*spvpSave.scale))
		spvp_planariteicon:SetLayer(2)
		spvp_planariteicon:SetPoint("TOPLEFT",spvp_overlay,"TOPLEFT",-spvp_planariteicon:GetTextureWidth()*(.24*spvpSave.scale)+1,spvp_background:GetHeight()*offset)
		spvp_planaritebar:SetPoint("TOPLEFT",spvp_overlay,"TOPLEFT",0,spvp_background:GetHeight()*offset)
		spvp_planaritebg:SetPoint("TOPLEFT",spvp_overlay,"TOPLEFT",0,spvp_background:GetHeight()*offset)
		spvp_planariteicon:SetVisible(false)
		--setup planarite bar
		local spvp_count = spvp_planarite.stack
		spvp_planarite_max = spvp_planarite.stackMax
		local spvp_percent = spvp_count/spvp_planarite_max
		spvp_planaritebar:SetWidth(spvp_percent*spvp_background:GetWidth())
		if spvp_percent >= 0.90 then
			spvp_planaritebar:SetTexture("SuperPVP","progress_high.png")
		else
			spvp_planaritebar:SetTexture("SuperPVP","progress_planarite.png")
		end
		--Set the XX/YY (%%) text
		SuperPVP.SetPlanarText(spvp_count)
		--draw the pictures
		spvp_planariteicon:SetVisible(true)
	end
end

function SuperPVP.SetPlanarText(spvp_planarite)
	spvp_planaritetext:SetFontSize(math.ceil(spvpSave.fontsize*spvpSave.scale))
	spvp_planaritetext:SetLayer(3)
	spvp_planaritetext:SetFontColor(1,1,1,1)
	local spvp_planarite_percent = (spvp_planarite/spvp_planarite_max)*100
	if spvp_planarite_percent >= 10 then
		spvp_planaritetext:SetText(tostring(spvp_planarite) .. "/" .. tostring(spvp_planarite_max) .. " " .. "(" .. string.sub(tostring(spvp_planarite_percent),1,2) .. "%)")
	else
		spvp_planaritetext:SetText(tostring(spvp_planarite) .. "/" .. tostring(spvp_planarite_max) .. " " .. "(" .. string.sub(tostring(spvp_planarite_percent),1,1) .. "%)")
	end
	local left,top,right,bottom = spvp_planaritebg:GetBounds()
	local lefttext,toptext,righttext,bottomtext = spvp_planaritetext:GetBounds()
	local repo = (right - righttext)/2
	spvp_planaritetext:SetPoint("CENTER",spvp_planaritebg,"CENTER",0,0)
	spvp_planaritetext:SetVisible(true)
end

function SuperPVP.PlanariteUpdate(spvp_curr)
	if spvpSave.planarite then
		for id,amount in pairs(spvp_curr) do
			if id == "I40FE419D87662CDA,018726C4E158FF25,,,,,," then
				if spvp_planarite_max then
					local spvp_percent = amount/spvp_planarite_max
					spvp_planaritebar:SetWidth(spvp_percent*spvp_background:GetWidth())
					spvp_planaritebar:SetWidth(spvp_percent*spvp_background:GetWidth())
					SuperPVP.SetPlanarText(amount)
					if spvp_percent >= 0.90 then
						spvp_planaritebar:SetTexture("SuperPVP","progress_high.png")
					else
						spvp_planaritebar:SetTexture("SuperPVP","progress_planarite.png")
				
					end
				end
			end
		end
	end
end

table.insert(Event.Currency, { SuperPVP.PlanariteUpdate, "SuperPVP", "Planarite Updated" } )